;##########################################################################
; Knob
; 02.05.2003
; coded by comrade <comrade2k@hotmail.com>
; IRC: #asm, #coders, #win32asm on EFnet
; Web: http://comrade64.cjb.net/
;      http://comrade.win32asm.com/
;##########################################################################
format PE GUI 4.0
entry start
;##########################################################################
include "%include%/win32a.inc"
include "%include%/macro/if.inc"
OFFSET equ
;##########################################################################
;##########################################################################
;##########################################################################
section ".code" code readable executable
;##########################################################################
start:
;##########################################################################
;##########################################################################
	stdcall [GetModuleHandle],0
	mov	[hInstance],eax
	stdcall [DialogBoxParam],eax,IDD_MAIN,0,OFFSET DlgProc,0
	stdcall [ExitProcess],0
;##########################################################################
proc DlgProc,hWnd,msg,wParam,lParam
	enter
	push	ebx esi edi
	; find message
	mov	eax,[msg]
	mov	edx,OFFSET mainmsg
.scan:	cmp	eax,[edx]
	jne	@F
	jmp	dword [edx+04h]
@@:	add	edx,08h
	cmp	dword [edx],0
	je	.quit
	jmp	.scan

.initdlg:	; INITDIALOG
	; append "About..." item to system menu
	stdcall [GetSystemMenu],[hWnd],0
	mov	ebx,eax
	stdcall [AppendMenu],eax,MFT_SEPARATOR,0,0
	stdcall [AppendMenu],ebx,MFT_STRING,10,OFFSET szMenuAbout
	stdcall [GetClientRect],[hWnd],OFFSET rc
	mov	eax,[rc.right]
	mov	ecx,[rc.bottom]
	mov	edx,[maxradius]
	shr	eax,1
	shr	ecx,1
	sub	ecx,20
	mov	[ptCenter.x],eax
	mov	[ptCenter.y],ecx
	sub	eax,edx
	sub	ecx,edx
	mov	[rcCircle.left],eax
	mov	[rcCircle.top],ecx
	add	edx,edx
	add	eax,edx
	add	ecx,edx
	mov	[rcCircle.right],eax
	mov	[rcCircle.bottom],ecx
	stdcall [CreatePen],PS_SOLID,3,00000000h
	mov	[hPenLine],eax
	jmp	.quit
.command:	; COMMAND
	mov	eax,[wParam]
	.if ax,e,ID_MAIN_ABOUT		; About
	.about: stdcall [MessageBox],[hWnd],OFFSET szMsgAbout,OFFSET szAppTitle,MB_OK+MB_ICONASTERISK+MB_APPLMODAL
	.elseif ax,e,ID_MAIN_CLOSE	; Close
		stdcall [PostMessage],[hWnd],WM_CLOSE,0,0
	.endif
	jmp	.quit
.syscommand:	; SYSCOMMAND
	cmp	[wParam],10
	je	.about
	jmp	.quit
.lbuttondown:	; LBUTTONDOWN
	stdcall [SetCapture],[hWnd]
	jmp	.quit
.mousemove:	; MOUSEMOVE
	stdcall [GetCapture]
	cmp	eax,[hWnd]
	jne	.quit
	;int	 3h
	movsx	eax,word [lParam+00h]
	movsx	ecx,word [lParam+02h]
	sub	eax,[ptCenter.x]
	sub	ecx,[ptCenter.y]
	mov	[pt.x],eax
	mov	[pt.y],ecx
	fild	[pt.y]
	fild	[pt.x]
	fmul	st0,st0
	fxch	st1
	fmul	st0,st0
	faddp	st1,st0
	fsqrt
	fistp	[radius]
	fild	[pt.y]
	fild	[pt.x]
	fdivp	st1,st0
	fild	[one]
	fpatan
	fabs
	fild	[halfcircle]
	fldpi
	fdivp	st1,st0
	fmulp	st1,st0
	fistp	[angle]
	; check for quadrant #1 (+x,-y)
	cmp	[pt.x],0
	jl	@F
	cmp	[pt.y],0
	jg	@F
	; quadrant #1
	jmp	.disp
@@:	; check for quadrant #2 (-x,-y)
	cmp	[pt.x],0
	jg	@F
	cmp	[pt.y],0
	jg	@F
	; quadrant #2
	sub	[angle],180
	neg	[angle]
	jmp	.disp
@@:	; check for quadrant #3 (-x,+y)
	cmp	[pt.x],0
	jg	@F
	cmp	[pt.y],0
	jl	@F
	; quadrant #3
	add	[angle],180
	jmp	.disp
@@:	; check for quadrant #4 (+x,+y)
	cmp	[pt.x],0
	jl	.disp
	cmp	[pt.y],0
	jl	.disp
	; quadrant #4
	sub	[angle],360
	neg	[angle]
	jmp	.disp
.disp:	ccall	[wsprintf],OFFSET szValue,OFFSET szValueFormat,[angle]
	stdcall [SetWindowText],[hWnd],OFFSET szValue
	stdcall [RedrawWindow],[hWnd],OFFSET rcCircle,0,RDW_ERASE+RDW_INVALIDATE
	jmp	.quit
.lbuttonup:	; LBUTTONUP
	stdcall [ReleaseCapture]
	jmp	.quit
.paint: 	; PAINT
	stdcall [BeginPaint],[hWnd],OFFSET ps
	stdcall [SelectObject],eax,[hPenLine]
	mov	eax,[ptCenter.x]
	mov	ebx,[ptCenter.y]
	mov	ecx,eax
	mov	edx,ebx
	sub	eax,[maxradius]
	sub	ebx,[maxradius]
	add	ecx,[maxradius]
	add	edx,[maxradius]
	stdcall [Ellipse],[ps.hdc],eax,ebx,ecx,edx
	stdcall [MoveToEx],[ps.hdc],[ptCenter.x],[ptCenter.y],0
	fild	[pt.y]
	fild	[pt.x]
	fmul	st0,st0
	fxch	st1
	fmul	st0,st0
	faddp	st1,st0
	fsqrt
	fild	[maxradius]
	fdivrp	st1,st0
	fld	st0
	fild	[pt.x]
	fmulp	st1,st0
	fistp	[pt.x]
	fild	[pt.y]
	fmulp	st1,st0
	fistp	[pt.y]
	mov	eax,[pt.x]
	mov	ecx,[pt.y]
	add	eax,[ptCenter.x]
	add	ecx,[ptCenter.y]
	stdcall [LineTo],[ps.hdc],eax,ecx
	stdcall [EndPaint],[hWnd],OFFSET ps
	jmp	.quit
.close: 	; CLOSE
	stdcall [DeleteObject],[hPenLine]
	stdcall [EndDialog],[hWnd],0
.quit:	xor	eax,eax
	pop	edi esi ebx
	return
;##########################################################################
;##########################################################################
;##########################################################################
;##########################################################################
section ".data" import data readable writeable
	library kernel32,"kernel32.dll",user32,"user32.dll",gdi32,"gdi32.dll"
	include "%include%/apia/kernel32.inc"
	include "%include%/apia/user32.inc"
	include "%include%/apia/gdi32.inc"
;##########################################################################
	szAppTitle	db	"Knob",0
	szMsgAbout	db	"Knob",13,10
			db	"coded by comrade <comrade2k@hotmail.com>",13,10
			db	"02.05.2003",13,10,13,10
			db	"IRC:	#asm, #coders, #win32asm on EFnet",13,10
			db	"Web:	http://comrade64.cjb.net/",13,10
			db	"	http://comrade.win32asm.com/",0
	szMenuAbout	db	"&About Knob...",0
	szValueFormat	db	"Knob - %4d",0
	one		dd	01
	halfcircle	dd	180
	maxradius	dd	40
	mainmsg 	dd	WM_INITDIALOG,DlgProc.initdlg
			dd	WM_COMMAND,DlgProc.command
			dd	WM_SYSCOMMAND,DlgProc.syscommand
			dd	WM_LBUTTONDOWN,DlgProc.lbuttondown
			dd	WM_MOUSEMOVE,DlgProc.mousemove
			dd	WM_LBUTTONUP,DlgProc.lbuttonup
			dd	WM_PAINT,DlgProc.paint
			dd	WM_CLOSE,DlgProc.close
			dd	0
;##########################################################################
	hInstance	rd	01h
	hPenLine	rd	01h
	radius		rd	01h
	angle		rd	01h
	szValue 	rb	40h
	rc		RECT
	rcCircle	RECT
	pt		POINT
	ptCenter	POINT
	ps		PAINTSTRUCT
;##########################################################################
section ".rsrc" resource data readable
	directory RT_DIALOG,dialogs
	; identifiers
	IDD_MAIN		= 20
	ID_MAIN_ABOUT		= 1
	ID_MAIN_CLOSE		= 2

	resource dialogs,IDD_MAIN,LANG_ENGLISH+SUBLANG_DEFAULT,main
	; main dialog
	dialog main,2,"Knob",0,0,200,120,DS_CENTER+WS_CAPTION+WS_SYSMENU+WS_MINIMIZEBOX,0,0,"Tahoma",8
		dialogitem "BUTTON","&About...",ID_MAIN_ABOUT,38,102,48,14,BS_DEFPUSHBUTTON+WS_TABSTOP+WS_VISIBLE
		dialogitem "BUTTON","&Close",ID_MAIN_CLOSE,114,102,48,14,BS_PUSHBUTTON+WS_TABSTOP+WS_VISIBLE
;##########################################################################
;##########################################################################